﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Chart_GettingStarted
{
	public partial class MainPage : ContentPage
	{
		public MainPage()
		{
			InitializeComponent();
		}
    }

    public class ViewModel : INotifyPropertyChanged
    {
        public List<Person> Data { get; set; }

        public ViewModel()
        {
            Data = new List<Person>()
            {
                new Person("A-Apple", 15),
                new Person("B-Ball", 11),
                new Person("C-Clothing", 20),
                new Person("G-Great", 40),
                new Person("H-Hotel", 50),
                new Person("I-Inasion", 45),
                new Person("J-Jobs", 14),
                new Person("K-Kit", 49)
            };
        }

        private int selectedIndex;
        private string _selectedItemName;

        public string SelectedItemName
        {
            get { return _selectedItemName; }
            set
            {
                _selectedItemName = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("SelectedItemName"));
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        public int SelectedIndex
        {
            get { return selectedIndex; }
            set
            {
                selectedIndex = value;
                if (selectedIndex == -1) return;

                SelectedItemName = Data[selectedIndex].XValue;
            }
        }
    }

    public class Person
    {
        public string XValue { get; set; }

        public double YValue { get; set; }

        public Person(string name, double value)
        {
            XValue = name;
            YValue = value;
        }
    }

    public class LegendWidthConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            double width = System.Convert.ToDouble(value);
            var segmentWidth = width / 2;
            return segmentWidth - 50;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }
    }
}
